summaryrefslogtreecommitdiffstats
path: root/network
diff options
context:
space:
mode:
author Emmanuel N. Millán <emmanueln@gmail.com>2015-08-19 06:25:23 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2015-08-21 03:25:02 +0700
commite47675285c54955d31bd821d94625bbd1d65e0da (patch)
tree50489ac66807e4bd033c45a3cfd1734768a63578 /network
parent6ac3d63979b80e5f18535fad3b50d9e4c5d4cf9b (diff)
downloadslackbuilds-e47675285c54955d31bd821d94625bbd1d65e0da.tar.gz
slackbuilds-e47675285c54955d31bd821d94625bbd1d65e0da.tar.xz
network/slurm: Added (workload manager).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'network')
-rw-r--r--network/slurm/README22
-rw-r--r--network/slurm/doinst.sh26
-rw-r--r--network/slurm/slack-desc19
-rw-r--r--network/slurm/slurm.SlackBuild123
-rw-r--r--network/slurm/slurm.info10
5 files changed, 200 insertions, 0 deletions
diff --git a/network/slurm/README b/network/slurm/README
new file mode 100644
index 0000000000..3aa4f86a18
--- /dev/null
+++ b/network/slurm/README
@@ -0,0 +1,22 @@
+Slurm Workload Manager
+
+Slurm is an open-source workload manager designed for Linux clusters of all sizes.
+It provides three key functions. First it allocates exclusive and/or non-exclusive
+access to resources (computer nodes) to users for some duration of time so they can
+perform work. Second, it provides a framework for starting, executing, and monitoring
+work (typically a parallel job) on a set of allocated nodes. Finally, it arbitrates
+contention for resources by managing a queue of pending work.
+
+The SLURM controller (slurmctld) can run without elevated privileges,
+so it is recommended that a user "slurm" be created for it before Slurm is executed.
+
+# groupadd -g 311 slurm
+# useradd -u 311 -d /var/lib/slurm -s /bin/false -g slurm slurm
+
+Next, a configuration file can be build using your favorite web browser and the
+file /usr/doc/slurm-14.11.8/html/configurator.html.
+
+Optional dependencies:
+HWLOC=yes|no (default: no), requires hwloc
+RRDTOOL=yes|no (default: no), requires rrdtool
+NUMA auto-detected, requires numactl
diff --git a/network/slurm/doinst.sh b/network/slurm/doinst.sh
new file mode 100644
index 0000000000..5995843bc0
--- /dev/null
+++ b/network/slurm/doinst.sh
@@ -0,0 +1,26 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/rc.d/rc.slurm.new
+preserve_perms etc/rc.d/rc.slurmdbd.new
diff --git a/network/slurm/slack-desc b/network/slurm/slack-desc
new file mode 100644
index 0000000000..819790444f
--- /dev/null
+++ b/network/slurm/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+slurm: slurm (workload manager)
+slurm:
+slurm: Slurm is an open-source workload manager designed for Linux clusters
+slurm: of all sizes. It provides three key functions. First it allocates
+slurm: exclusive and/or non-exclusive access to resources (computer nodes)
+slurm: to users for some duration of time so they can perform work. Second,
+slurm: It provides a framework for starting, executing, and monitoring work
+slurm: (typically a parallel job) on a set of allocated nodes. Finally, it
+slurm: arbitrates contention for resources by managing a queue of pending
+slurm: work.
+slurm: http://slurm.schedmd.com/
diff --git a/network/slurm/slurm.SlackBuild b/network/slurm/slurm.SlackBuild
new file mode 100644
index 0000000000..e37fc7fd99
--- /dev/null
+++ b/network/slurm/slurm.SlackBuild
@@ -0,0 +1,123 @@
+#!/bin/sh -e
+
+# Slackware build script for Slurm
+
+# Copyright 2015 Emmanuel N. Millán, Mendoza, Argentina.
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=slurm
+VERSION=${VERSION:-14.11.8}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+DOCS="AUTHORS BUILD.NOTES COPYING DISCLAIMER INSTALL LICENSE.OpenSSL \
+ META NEWS README.rst RELEASE_NOTES"
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+HWLOC=${HWLOC:-no}
+HWLOC_SUPPORT=""
+[ "$HWLOC" = "yes" ] && HWLOC_SUPPORT="--with-hwloc"
+
+RRDTOOL=${RRDTOOL:-no}
+RRDTOOL_SUPPORT=""
+[ "$RRDTOOL" = "yes" ] && RRDTOOL_SUPPORT="--with-rrdtool"
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.?z*
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --localstatedir=/var \
+ --datarootdir=/usr \
+ --mandir=/usr/man \
+ --sysconfdir=/etc \
+ --enable-static=no \
+ $HWLOC_SUPPORT \
+ $RRDTOOL_SUPPORT \
+ --build=$ARCH-slackware-linux \
+ --host=$ARCH-slackware-linux
+
+make
+make install DESTDIR=$PKG
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/etc/slurm
+mkdir -p $PKG/etc/rc.d/
+cp -a etc/slurm.conf.example $PKG/etc/slurm/slurm.conf.example
+cp -a etc/slurmdbd.conf.example $PKG/etc/slurm/slurmdbd.conf.example
+cp -a etc/init.d.slurm $PKG/etc/rc.d/rc.slurm.new
+cp -a etc/init.d.slurmdbd $PKG/etc/rc.d/rc.slurmdbd.new
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/network/slurm/slurm.info b/network/slurm/slurm.info
new file mode 100644
index 0000000000..4984565e50
--- /dev/null
+++ b/network/slurm/slurm.info
@@ -0,0 +1,10 @@
+PRGNAM="slurm"
+VERSION="14.11.8"
+HOMEPAGE="http://slurm.schedmd.com/"
+DOWNLOAD="http://www.schedmd.com/download/latest/slurm-14.11.8.tar.bz2"
+MD5SUM="6bd8b788aa91e3e88c57858cc9c4d3bf"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="munge"
+MAINTAINER="Emmanuel N. Millán"
+EMAIL="emmanueln@gmail.com"